PingOne Platform APIs - Early Access

Create Authorization Policy

 

POST {{apiPath}}/environments/{{envID}}/authorizationPolicies

The POST {{apiPath}}/environments/{{envID}}/authorizationPolicies request creates a new authorization policy.

Request Model

For property descriptions, refer to Authorization policies data model

Property Type? Required?

children

Array

Optional

combiningAlgorithm

Object

Required

condition

Object

Optional

description

String

Optional

enabled

Boolean

Optional

name

String

Required

repetitionSettings

Object

Optional

statements

Object

Optional

type

String

Required

Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

Body

raw ( application/json )

{
  "type": "POLICY",
  "name": "Policy1",
  "description": "Policy1 description",
  "enabled": true,
  "statements": [
    {
      "value": {
        "id": "{{authorizationStatementID}}"
      }
    },
    {
      "name": "Statement1",
      "description": "Statement1 description",
      "code": "CODE1",
      "appliesTo": "PERMIT_OR_DENY",
      "appliesIf": "FINAL_DECISION_MATCHES",
      "payload": "Payload1",
      "obligatory": false,
      "attributes": [],
      "services": []
    }
  ],
  "condition": {
    "type": "AND",
    "conditions": [
      {
        "type": "COMPARISON",
        "left": {
          "type": "ATTRIBUTE",
          "id": "{{authAttributeID}}"
        },
        "comparator": "EQUALS",
        "right": {
          "type": "CONSTANT",
          "value": "def"
        }
      }
    ]
  },
  "combiningAlgorithm": {
    "algorithm": "DENY_OVERRIDES"
  },
  "children": [
    {
      "type": "POLICY",
      "value": {
        "id": "{{authChildPolicyID}}"
      }
    },
    {
      "type": "POLICY",
      "name": "Policy2",
      "description": "Policy2 description",
      "enabled": true,
      "statements": [],
      "combiningAlgorithm": {
        "algorithm": "PERMIT_UNLESS_DENY"
      },
      "children": [
        {
          "type": "RULE",
          "value": {
            "id": "{{authChildRuleID}}"
          }
        },
        {
          "type": "RULE",
          "name": "Rule1",
          "description": "Rule1 description",
          "enabled": true,
          "statements": [],
          "effectSettings": {
            "type": "UNCONDITIONAL_PERMIT"
          }
        }
      ],
      "repetitionSettings": {
        "source": {
          "id": "{{authRepetitionSettingsID}}"
        },
        "decision": "PERMIT"
      }
    }
  ]
}

Example Request

  • cURL

  • C#

  • Go

  • HTTP

  • Java

  • jQuery

  • NodeJS

  • Python

  • PHP

  • Ruby

  • Swift

curl --location --globoff '{{apiPath}}/environments/{{envID}}/authorizationPolicies' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
  "type": "POLICY",
  "name": "Policy1",
  "description": "Policy1 description",
  "enabled": true,
  "statements": [
    {
      "value": {
        "id": "{{authorizationStatementID}}"
      }
    },
    {
      "name": "Statement1",
      "description": "Statement1 description",
      "code": "CODE1",
      "appliesTo": "PERMIT_OR_DENY",
      "appliesIf": "FINAL_DECISION_MATCHES",
      "payload": "Payload1",
      "obligatory": false,
      "attributes": [],
      "services": []
    }
  ],
  "condition": {
    "type": "AND",
    "conditions": [
      {
        "type": "COMPARISON",
        "left": {
          "type": "ATTRIBUTE",
          "id": "{{authAttributeID}}"
        },
        "comparator": "EQUALS",
        "right": {
          "type": "CONSTANT",
          "value": "def"
        }
      }
    ]
  },
  "combiningAlgorithm": {
    "algorithm": "DENY_OVERRIDES"
  },
  "children": [
    {
      "type": "POLICY",
      "value": {
        "id": "{{authChildPolicyID}}"
      }
    },
    {
      "type": "POLICY",
      "name": "Policy2",
      "description": "Policy2 description",
      "enabled": true,
      "statements": [],
      "combiningAlgorithm": {
        "algorithm": "PERMIT_UNLESS_DENY"
      },
      "children": [
        {
          "type": "RULE",
          "value": {
            "id": "{{authChildRuleID}}"
          }
        },
        {
          "type": "RULE",
          "name": "Rule1",
          "description": "Rule1 description",
          "enabled": true,
          "statements": [],
          "effectSettings": {
            "type": "UNCONDITIONAL_PERMIT"
          }
        }
      ],
      "repetitionSettings": {
        "source": {
          "id": "{{authRepetitionSettingsID}}"
        },
        "decision": "PERMIT"
      }
    }
  ]
}'
var options = new RestClientOptions("{{apiPath}}/environments/{{envID}}/authorizationPolicies")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"" + "\n" +
@"{" + "\n" +
@"  ""type"": ""POLICY""," + "\n" +
@"  ""name"": ""Policy1""," + "\n" +
@"  ""description"": ""Policy1 description""," + "\n" +
@"  ""enabled"": true," + "\n" +
@"  ""statements"": [" + "\n" +
@"    {" + "\n" +
@"      ""value"": {" + "\n" +
@"        ""id"": ""{{authorizationStatementID}}""" + "\n" +
@"      }" + "\n" +
@"    }," + "\n" +
@"    {" + "\n" +
@"      ""name"": ""Statement1""," + "\n" +
@"      ""description"": ""Statement1 description""," + "\n" +
@"      ""code"": ""CODE1""," + "\n" +
@"      ""appliesTo"": ""PERMIT_OR_DENY""," + "\n" +
@"      ""appliesIf"": ""FINAL_DECISION_MATCHES""," + "\n" +
@"      ""payload"": ""Payload1""," + "\n" +
@"      ""obligatory"": false," + "\n" +
@"      ""attributes"": []," + "\n" +
@"      ""services"": []" + "\n" +
@"    }" + "\n" +
@"  ]," + "\n" +
@"  ""condition"": {" + "\n" +
@"    ""type"": ""AND""," + "\n" +
@"    ""conditions"": [" + "\n" +
@"      {" + "\n" +
@"        ""type"": ""COMPARISON""," + "\n" +
@"        ""left"": {" + "\n" +
@"          ""type"": ""ATTRIBUTE""," + "\n" +
@"          ""id"": ""{{authAttributeID}}""" + "\n" +
@"        }," + "\n" +
@"        ""comparator"": ""EQUALS""," + "\n" +
@"        ""right"": {" + "\n" +
@"          ""type"": ""CONSTANT""," + "\n" +
@"          ""value"": ""def""        " + "\n" +
@"        }" + "\n" +
@"      }" + "\n" +
@"    ]" + "\n" +
@"  }," + "\n" +
@"  ""combiningAlgorithm"": {" + "\n" +
@"    ""algorithm"": ""DENY_OVERRIDES""" + "\n" +
@"  }," + "\n" +
@"  ""children"": [" + "\n" +
@"    {" + "\n" +
@"      ""type"": ""POLICY""," + "\n" +
@"      ""value"": {" + "\n" +
@"        ""id"": ""{{authChildPolicyID}}""" + "\n" +
@"      }" + "\n" +
@"    }," + "\n" +
@"    {" + "\n" +
@"      ""type"": ""POLICY""," + "\n" +
@"      ""name"": ""Policy2""," + "\n" +
@"      ""description"": ""Policy2 description""," + "\n" +
@"      ""enabled"": true," + "\n" +
@"      ""statements"": []," + "\n" +
@"      ""combiningAlgorithm"": {" + "\n" +
@"        ""algorithm"": ""PERMIT_UNLESS_DENY""" + "\n" +
@"      }," + "\n" +
@"      ""children"": [" + "\n" +
@"        {" + "\n" +
@"          ""type"": ""RULE""," + "\n" +
@"          ""value"": {" + "\n" +
@"            ""id"": ""{{authChildRuleID}}""" + "\n" +
@"          }" + "\n" +
@"        }," + "\n" +
@"        {" + "\n" +
@"          ""type"": ""RULE""," + "\n" +
@"          ""name"": ""Rule1""," + "\n" +
@"          ""description"": ""Rule1 description""," + "\n" +
@"          ""enabled"": true," + "\n" +
@"          ""statements"": []," + "\n" +
@"          ""effectSettings"": {" + "\n" +
@"            ""type"": ""UNCONDITIONAL_PERMIT""" + "\n" +
@"          }" + "\n" +
@"        }" + "\n" +
@"      ]," + "\n" +
@"      ""repetitionSettings"": {" + "\n" +
@"        ""source"": {" + "\n" +
@"          ""id"": ""{{authRepetitionSettingsID}}""" + "\n" +
@"        }," + "\n" +
@"        ""decision"": ""PERMIT""" + "\n" +
@"      }" + "\n" +
@"    }" + "\n" +
@"  ]" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/environments/{{envID}}/authorizationPolicies"
  method := "POST"

  payload := strings.NewReader(`{
  "type": "POLICY",
  "name": "Policy1",
  "description": "Policy1 description",
  "enabled": true,
  "statements": [
    {
      "value": {
        "id": "{{authorizationStatementID}}"
      }
    },
    {
      "name": "Statement1",
      "description": "Statement1 description",
      "code": "CODE1",
      "appliesTo": "PERMIT_OR_DENY",
      "appliesIf": "FINAL_DECISION_MATCHES",
      "payload": "Payload1",
      "obligatory": false,
      "attributes": [],
      "services": []
    }
  ],
  "condition": {
    "type": "AND",
    "conditions": [
      {
        "type": "COMPARISON",
        "left": {
          "type": "ATTRIBUTE",
          "id": "{{authAttributeID}}"
        },
        "comparator": "EQUALS",
        "right": {
          "type": "CONSTANT",
          "value": "def"
        }
      }
    ]
  },
  "combiningAlgorithm": {
    "algorithm": "DENY_OVERRIDES"
  },
  "children": [
    {
      "type": "POLICY",
      "value": {
        "id": "{{authChildPolicyID}}"
      }
    },
    {
      "type": "POLICY",
      "name": "Policy2",
      "description": "Policy2 description",
      "enabled": true,
      "statements": [],
      "combiningAlgorithm": {
        "algorithm": "PERMIT_UNLESS_DENY"
      },
      "children": [
        {
          "type": "RULE",
          "value": {
            "id": "{{authChildRuleID}}"
          }
        },
        {
          "type": "RULE",
          "name": "Rule1",
          "description": "Rule1 description",
          "enabled": true,
          "statements": [],
          "effectSettings": {
            "type": "UNCONDITIONAL_PERMIT"
          }
        }
      ],
      "repetitionSettings": {
        "source": {
          "id": "{{authRepetitionSettingsID}}"
        },
        "decision": "PERMIT"
      }
    }
  ]
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
POST /environments/{{envID}}/authorizationPolicies HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
  "type": "POLICY",
  "name": "Policy1",
  "description": "Policy1 description",
  "enabled": true,
  "statements": [
    {
      "value": {
        "id": "{{authorizationStatementID}}"
      }
    },
    {
      "name": "Statement1",
      "description": "Statement1 description",
      "code": "CODE1",
      "appliesTo": "PERMIT_OR_DENY",
      "appliesIf": "FINAL_DECISION_MATCHES",
      "payload": "Payload1",
      "obligatory": false,
      "attributes": [],
      "services": []
    }
  ],
  "condition": {
    "type": "AND",
    "conditions": [
      {
        "type": "COMPARISON",
        "left": {
          "type": "ATTRIBUTE",
          "id": "{{authAttributeID}}"
        },
        "comparator": "EQUALS",
        "right": {
          "type": "CONSTANT",
          "value": "def"
        }
      }
    ]
  },
  "combiningAlgorithm": {
    "algorithm": "DENY_OVERRIDES"
  },
  "children": [
    {
      "type": "POLICY",
      "value": {
        "id": "{{authChildPolicyID}}"
      }
    },
    {
      "type": "POLICY",
      "name": "Policy2",
      "description": "Policy2 description",
      "enabled": true,
      "statements": [],
      "combiningAlgorithm": {
        "algorithm": "PERMIT_UNLESS_DENY"
      },
      "children": [
        {
          "type": "RULE",
          "value": {
            "id": "{{authChildRuleID}}"
          }
        },
        {
          "type": "RULE",
          "name": "Rule1",
          "description": "Rule1 description",
          "enabled": true,
          "statements": [],
          "effectSettings": {
            "type": "UNCONDITIONAL_PERMIT"
          }
        }
      ],
      "repetitionSettings": {
        "source": {
          "id": "{{authRepetitionSettingsID}}"
        },
        "decision": "PERMIT"
      }
    }
  ]
}
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "\n{\n  \"type\": \"POLICY\",\n  \"name\": \"Policy1\",\n  \"description\": \"Policy1 description\",\n  \"enabled\": true,\n  \"statements\": [\n    {\n      \"value\": {\n        \"id\": \"{{authorizationStatementID}}\"\n      }\n    },\n    {\n      \"name\": \"Statement1\",\n      \"description\": \"Statement1 description\",\n      \"code\": \"CODE1\",\n      \"appliesTo\": \"PERMIT_OR_DENY\",\n      \"appliesIf\": \"FINAL_DECISION_MATCHES\",\n      \"payload\": \"Payload1\",\n      \"obligatory\": false,\n      \"attributes\": [],\n      \"services\": []\n    }\n  ],\n  \"condition\": {\n    \"type\": \"AND\",\n    \"conditions\": [\n      {\n        \"type\": \"COMPARISON\",\n        \"left\": {\n          \"type\": \"ATTRIBUTE\",\n          \"id\": \"{{authAttributeID}}\"\n        },\n        \"comparator\": \"EQUALS\",\n        \"right\": {\n          \"type\": \"CONSTANT\",\n          \"value\": \"def\"        \n        }\n      }\n    ]\n  },\n  \"combiningAlgorithm\": {\n    \"algorithm\": \"DENY_OVERRIDES\"\n  },\n  \"children\": [\n    {\n      \"type\": \"POLICY\",\n      \"value\": {\n        \"id\": \"{{authChildPolicyID}}\"\n      }\n    },\n    {\n      \"type\": \"POLICY\",\n      \"name\": \"Policy2\",\n      \"description\": \"Policy2 description\",\n      \"enabled\": true,\n      \"statements\": [],\n      \"combiningAlgorithm\": {\n        \"algorithm\": \"PERMIT_UNLESS_DENY\"\n      },\n      \"children\": [\n        {\n          \"type\": \"RULE\",\n          \"value\": {\n            \"id\": \"{{authChildRuleID}}\"\n          }\n        },\n        {\n          \"type\": \"RULE\",\n          \"name\": \"Rule1\",\n          \"description\": \"Rule1 description\",\n          \"enabled\": true,\n          \"statements\": [],\n          \"effectSettings\": {\n            \"type\": \"UNCONDITIONAL_PERMIT\"\n          }\n        }\n      ],\n      \"repetitionSettings\": {\n        \"source\": {\n          \"id\": \"{{authRepetitionSettingsID}}\"\n        },\n        \"decision\": \"PERMIT\"\n      }\n    }\n  ]\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/environments/{{envID}}/authorizationPolicies")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
var settings = {
  "url": "{{apiPath}}/environments/{{envID}}/authorizationPolicies",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "type": "POLICY",
    "name": "Policy1",
    "description": "Policy1 description",
    "enabled": true,
    "statements": [
      {
        "value": {
          "id": "{{authorizationStatementID}}"
        }
      },
      {
        "name": "Statement1",
        "description": "Statement1 description",
        "code": "CODE1",
        "appliesTo": "PERMIT_OR_DENY",
        "appliesIf": "FINAL_DECISION_MATCHES",
        "payload": "Payload1",
        "obligatory": false,
        "attributes": [],
        "services": []
      }
    ],
    "condition": {
      "type": "AND",
      "conditions": [
        {
          "type": "COMPARISON",
          "left": {
            "type": "ATTRIBUTE",
            "id": "{{authAttributeID}}"
          },
          "comparator": "EQUALS",
          "right": {
            "type": "CONSTANT",
            "value": "def"
          }
        }
      ]
    },
    "combiningAlgorithm": {
      "algorithm": "DENY_OVERRIDES"
    },
    "children": [
      {
        "type": "POLICY",
        "value": {
          "id": "{{authChildPolicyID}}"
        }
      },
      {
        "type": "POLICY",
        "name": "Policy2",
        "description": "Policy2 description",
        "enabled": true,
        "statements": [],
        "combiningAlgorithm": {
          "algorithm": "PERMIT_UNLESS_DENY"
        },
        "children": [
          {
            "type": "RULE",
            "value": {
              "id": "{{authChildRuleID}}"
            }
          },
          {
            "type": "RULE",
            "name": "Rule1",
            "description": "Rule1 description",
            "enabled": true,
            "statements": [],
            "effectSettings": {
              "type": "UNCONDITIONAL_PERMIT"
            }
          }
        ],
        "repetitionSettings": {
          "source": {
            "id": "{{authRepetitionSettingsID}}"
          },
          "decision": "PERMIT"
        }
      }
    ]
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/environments/{{envID}}/authorizationPolicies',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "type": "POLICY",
    "name": "Policy1",
    "description": "Policy1 description",
    "enabled": true,
    "statements": [
      {
        "value": {
          "id": "{{authorizationStatementID}}"
        }
      },
      {
        "name": "Statement1",
        "description": "Statement1 description",
        "code": "CODE1",
        "appliesTo": "PERMIT_OR_DENY",
        "appliesIf": "FINAL_DECISION_MATCHES",
        "payload": "Payload1",
        "obligatory": false,
        "attributes": [],
        "services": []
      }
    ],
    "condition": {
      "type": "AND",
      "conditions": [
        {
          "type": "COMPARISON",
          "left": {
            "type": "ATTRIBUTE",
            "id": "{{authAttributeID}}"
          },
          "comparator": "EQUALS",
          "right": {
            "type": "CONSTANT",
            "value": "def"
          }
        }
      ]
    },
    "combiningAlgorithm": {
      "algorithm": "DENY_OVERRIDES"
    },
    "children": [
      {
        "type": "POLICY",
        "value": {
          "id": "{{authChildPolicyID}}"
        }
      },
      {
        "type": "POLICY",
        "name": "Policy2",
        "description": "Policy2 description",
        "enabled": true,
        "statements": [],
        "combiningAlgorithm": {
          "algorithm": "PERMIT_UNLESS_DENY"
        },
        "children": [
          {
            "type": "RULE",
            "value": {
              "id": "{{authChildRuleID}}"
            }
          },
          {
            "type": "RULE",
            "name": "Rule1",
            "description": "Rule1 description",
            "enabled": true,
            "statements": [],
            "effectSettings": {
              "type": "UNCONDITIONAL_PERMIT"
            }
          }
        ],
        "repetitionSettings": {
          "source": {
            "id": "{{authRepetitionSettingsID}}"
          },
          "decision": "PERMIT"
        }
      }
    ]
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
import requests
import json

url = "{{apiPath}}/environments/{{envID}}/authorizationPolicies"

payload = json.dumps({
  "type": "POLICY",
  "name": "Policy1",
  "description": "Policy1 description",
  "enabled": True,
  "statements": [
    {
      "value": {
        "id": "{{authorizationStatementID}}"
      }
    },
    {
      "name": "Statement1",
      "description": "Statement1 description",
      "code": "CODE1",
      "appliesTo": "PERMIT_OR_DENY",
      "appliesIf": "FINAL_DECISION_MATCHES",
      "payload": "Payload1",
      "obligatory": False,
      "attributes": [],
      "services": []
    }
  ],
  "condition": {
    "type": "AND",
    "conditions": [
      {
        "type": "COMPARISON",
        "left": {
          "type": "ATTRIBUTE",
          "id": "{{authAttributeID}}"
        },
        "comparator": "EQUALS",
        "right": {
          "type": "CONSTANT",
          "value": "def"
        }
      }
    ]
  },
  "combiningAlgorithm": {
    "algorithm": "DENY_OVERRIDES"
  },
  "children": [
    {
      "type": "POLICY",
      "value": {
        "id": "{{authChildPolicyID}}"
      }
    },
    {
      "type": "POLICY",
      "name": "Policy2",
      "description": "Policy2 description",
      "enabled": True,
      "statements": [],
      "combiningAlgorithm": {
        "algorithm": "PERMIT_UNLESS_DENY"
      },
      "children": [
        {
          "type": "RULE",
          "value": {
            "id": "{{authChildRuleID}}"
          }
        },
        {
          "type": "RULE",
          "name": "Rule1",
          "description": "Rule1 description",
          "enabled": True,
          "statements": [],
          "effectSettings": {
            "type": "UNCONDITIONAL_PERMIT"
          }
        }
      ],
      "repetitionSettings": {
        "source": {
          "id": "{{authRepetitionSettingsID}}"
        },
        "decision": "PERMIT"
      }
    }
  ]
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/environments/{{envID}}/authorizationPolicies');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n  "type": "POLICY",\n  "name": "Policy1",\n  "description": "Policy1 description",\n  "enabled": true,\n  "statements": [\n    {\n      "value": {\n        "id": "{{authorizationStatementID}}"\n      }\n    },\n    {\n      "name": "Statement1",\n      "description": "Statement1 description",\n      "code": "CODE1",\n      "appliesTo": "PERMIT_OR_DENY",\n      "appliesIf": "FINAL_DECISION_MATCHES",\n      "payload": "Payload1",\n      "obligatory": false,\n      "attributes": [],\n      "services": []\n    }\n  ],\n  "condition": {\n    "type": "AND",\n    "conditions": [\n      {\n        "type": "COMPARISON",\n        "left": {\n          "type": "ATTRIBUTE",\n          "id": "{{authAttributeID}}"\n        },\n        "comparator": "EQUALS",\n        "right": {\n          "type": "CONSTANT",\n          "value": "def"        \n        }\n      }\n    ]\n  },\n  "combiningAlgorithm": {\n    "algorithm": "DENY_OVERRIDES"\n  },\n  "children": [\n    {\n      "type": "POLICY",\n      "value": {\n        "id": "{{authChildPolicyID}}"\n      }\n    },\n    {\n      "type": "POLICY",\n      "name": "Policy2",\n      "description": "Policy2 description",\n      "enabled": true,\n      "statements": [],\n      "combiningAlgorithm": {\n        "algorithm": "PERMIT_UNLESS_DENY"\n      },\n      "children": [\n        {\n          "type": "RULE",\n          "value": {\n            "id": "{{authChildRuleID}}"\n          }\n        },\n        {\n          "type": "RULE",\n          "name": "Rule1",\n          "description": "Rule1 description",\n          "enabled": true,\n          "statements": [],\n          "effectSettings": {\n            "type": "UNCONDITIONAL_PERMIT"\n          }\n        }\n      ],\n      "repetitionSettings": {\n        "source": {\n          "id": "{{authRepetitionSettingsID}}"\n        },\n        "decision": "PERMIT"\n      }\n    }\n  ]\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/environments/{{envID}}/authorizationPolicies")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "type": "POLICY",
  "name": "Policy1",
  "description": "Policy1 description",
  "enabled": true,
  "statements": [
    {
      "value": {
        "id": "{{authorizationStatementID}}"
      }
    },
    {
      "name": "Statement1",
      "description": "Statement1 description",
      "code": "CODE1",
      "appliesTo": "PERMIT_OR_DENY",
      "appliesIf": "FINAL_DECISION_MATCHES",
      "payload": "Payload1",
      "obligatory": false,
      "attributes": [],
      "services": []
    }
  ],
  "condition": {
    "type": "AND",
    "conditions": [
      {
        "type": "COMPARISON",
        "left": {
          "type": "ATTRIBUTE",
          "id": "{{authAttributeID}}"
        },
        "comparator": "EQUALS",
        "right": {
          "type": "CONSTANT",
          "value": "def"
        }
      }
    ]
  },
  "combiningAlgorithm": {
    "algorithm": "DENY_OVERRIDES"
  },
  "children": [
    {
      "type": "POLICY",
      "value": {
        "id": "{{authChildPolicyID}}"
      }
    },
    {
      "type": "POLICY",
      "name": "Policy2",
      "description": "Policy2 description",
      "enabled": true,
      "statements": [],
      "combiningAlgorithm": {
        "algorithm": "PERMIT_UNLESS_DENY"
      },
      "children": [
        {
          "type": "RULE",
          "value": {
            "id": "{{authChildRuleID}}"
          }
        },
        {
          "type": "RULE",
          "name": "Rule1",
          "description": "Rule1 description",
          "enabled": true,
          "statements": [],
          "effectSettings": {
            "type": "UNCONDITIONAL_PERMIT"
          }
        }
      ],
      "repetitionSettings": {
        "source": {
          "id": "{{authRepetitionSettingsID}}"
        },
        "decision": "PERMIT"
      }
    }
  ]
})

response = http.request(request)
puts response.read_body
let parameters = "{\n  \"type\": \"POLICY\",\n  \"name\": \"Policy1\",\n  \"description\": \"Policy1 description\",\n  \"enabled\": true,\n  \"statements\": [\n    {\n      \"value\": {\n        \"id\": \"{{authorizationStatementID}}\"\n      }\n    },\n    {\n      \"name\": \"Statement1\",\n      \"description\": \"Statement1 description\",\n      \"code\": \"CODE1\",\n      \"appliesTo\": \"PERMIT_OR_DENY\",\n      \"appliesIf\": \"FINAL_DECISION_MATCHES\",\n      \"payload\": \"Payload1\",\n      \"obligatory\": false,\n      \"attributes\": [],\n      \"services\": []\n    }\n  ],\n  \"condition\": {\n    \"type\": \"AND\",\n    \"conditions\": [\n      {\n        \"type\": \"COMPARISON\",\n        \"left\": {\n          \"type\": \"ATTRIBUTE\",\n          \"id\": \"{{authAttributeID}}\"\n        },\n        \"comparator\": \"EQUALS\",\n        \"right\": {\n          \"type\": \"CONSTANT\",\n          \"value\": \"def\"        \n        }\n      }\n    ]\n  },\n  \"combiningAlgorithm\": {\n    \"algorithm\": \"DENY_OVERRIDES\"\n  },\n  \"children\": [\n    {\n      \"type\": \"POLICY\",\n      \"value\": {\n        \"id\": \"{{authChildPolicyID}}\"\n      }\n    },\n    {\n      \"type\": \"POLICY\",\n      \"name\": \"Policy2\",\n      \"description\": \"Policy2 description\",\n      \"enabled\": true,\n      \"statements\": [],\n      \"combiningAlgorithm\": {\n        \"algorithm\": \"PERMIT_UNLESS_DENY\"\n      },\n      \"children\": [\n        {\n          \"type\": \"RULE\",\n          \"value\": {\n            \"id\": \"{{authChildRuleID}}\"\n          }\n        },\n        {\n          \"type\": \"RULE\",\n          \"name\": \"Rule1\",\n          \"description\": \"Rule1 description\",\n          \"enabled\": true,\n          \"statements\": [],\n          \"effectSettings\": {\n            \"type\": \"UNCONDITIONAL_PERMIT\"\n          }\n        }\n      ],\n      \"repetitionSettings\": {\n        \"source\": {\n          \"id\": \"{{authRepetitionSettingsID}}\"\n        },\n        \"decision\": \"PERMIT\"\n      }\n    }\n  ]\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/environments/{{envID}}/authorizationPolicies")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()

Example Response

201 Created

{
  "_links": {
    "self": {
      "href": "https://api.pingone.com/v1/environments/{envID}/authorizationPolicies/d735fd88-96a3-4532-bc05-e69a0173dd59"
    },
    "policies": [
      {
        "href": "https://api.pingone.com/v1/environments/{envID}/authorizationPolicies/6916f0ca-50bd-4025-a16e-c3b5eed62d20"
      }
    ],
    "rules": [
      {
        "href": "https://api.pingone.com/v1/environments/{envID}/authorizationRules/4c7aa845-febd-4427-bec2-36813370806d"
      }
    ],
    "statements": [
      {
        "href": "https://api.pingone.com/v1/environments/{envID}/authorizationStatements/619243fd-5e18-43e4-a97c-9fda2fcb727a"
      }
    ],
    "attributes": [
      {
        "href": "https://api.pingone.com/v1/environments/{envID}/authorizationAttributes/779f8ccb-9f74-4fa2-826a-ecdd64ec4a3b"
      }
    ]
  },
  "type": "POLICY",
  "id": "d735fd88-96a3-4532-bc05-e69a0173dd59",
  "version": "0e8dbef9-b342-4658-8767-6695c1138b57",
  "name": "Policy1",
  "description": "Policy1 description",
  "enabled": true,
  "statements": [
    {
      "value": {
        "id": "619243fd-5e18-43e4-a97c-9fda2fcb727a"
      }
    },
    {
      "name": "Statement1",
      "description": "Statement1 description",
      "code": "CODE1",
      "appliesTo": "PERMIT_OR_DENY",
      "appliesIf": "FINAL_DECISION_MATCHES",
      "payload": "Payload1",
      "obligatory": false,
      "attributes": [],
      "services": []
    }
  ],
  "condition": {
    "type": "AND",
    "conditions": [
      {
        "type": "COMPARISON",
        "left": {
          "type": "ATTRIBUTE",
          "id": "779f8ccb-9f74-4fa2-826a-ecdd64ec4a3b"
        },
        "comparator": "EQUALS",
        "right": {
          "type": "CONSTANT",
          "value": "def"
        }
      }
    ]
  },
  "combiningAlgorithm": {
    "algorithm": "DENY_OVERRIDES"
  },
  "children": [
    {
      "type": "POLICY",
      "value": {
        "id": "6916f0ca-50bd-4025-a16e-c3b5eed62d20"
      }
    },
    {
      "type": "POLICY",
      "name": "Policy2",
      "description": "Policy2 description",
      "enabled": true,
      "statements": [],
      "combiningAlgorithm": {
        "algorithm": "PERMIT_UNLESS_DENY"
      },
      "children": [
        {
          "type": "RULE",
          "value": {
            "id": "4c7aa845-febd-4427-bec2-36813370806d"
          }
        },
        {
          "type": "RULE",
          "name": "Rule1",
          "description": "Rule1 description",
          "enabled": true,
          "statements": [],
          "effectSettings": {
            "type": "UNCONDITIONAL_PERMIT"
          }
        }
      ],
      "repetitionSettings": {
        "source": {
          "id": "779f8ccb-9f74-4fa2-826a-ecdd64ec4a3b"
        },
        "decision": "PERMIT"
      }
    }
  ]
}